<template>
  <main>
    <form @submit.prevent="sendForm()">
      <div class="columns">
        <div class="column">
          <ec-field
            field-id="firstname"
          >
            <template #label>
              Votre prénom <small>facultatif</small>
            </template>
            <input
              id="firstname"
              v-model="fields.firstname"
              name="firstname"
              type="text"
              class="input"
              placeholder="Tapez votre prénom"
            >
          </ec-field>
        </div>

        <div class="column">
          <ec-field
            field-id="lastname"
          >
            <template #label>
              Votre nom <small>facultatif</small>
            </template>
            <input
              id="lastname"
              v-model="fields.lastname"
              type="text"
              class="input"
              name="lastname"
              placeholder="Tapez votre nom"
            >
          </ec-field>
        </div>
      </div>
      <div class="columns">
        <div class="column">
          <ec-field
            field-id="email"
          >
            <template #label>
              Votre Email <validation-icon-switch :state="fields.email_confirmed" />
            </template>
            <div class="field has-addons">
              <div class="control is-expanded">
                <input
                  id="email"
                  v-model="fields.email"
                  type="text"
                  class="input"
                  name="email"
                  placeholder="Tapez votre email"
                >
              </div>
              <div
                v-if="old.email !== fields.email || !fields.email_confirmed"
                class="control"
              >
                <button
                  type="button"
                  class="button is-primary"
                  @click="sendForm('email')"
                >
                  Vérifier
                </button>
              </div>
            </div>
          </ec-field>
        </div>
        <div class="column">
          <ec-field
            v-if="old.email !== fields.email || !fields.email_confirmed"
            field-id="email_token"
            label="Code de confirmation courriel"
          >
            <div class="field has-addons">
              <div class="control is-expanded">
                <input
                  id="email_token"
                  v-model="fields.email_token"
                  type="text"
                  class="input"
                  name="email_token"
                  :disabled="fields.email_confirmed"
                  placeholder="Tapez le jeton de confirmation reçu sur votre courriel"
                >
              </div>
              <div class="control">
                <button
                  type="button"
                  class="button is-primary"
                  :disabled="fields.email_confirmed"
                  @click="sendForm('email')"
                >
                  OK
                </button>
              </div>
            </div>
          </ec-field>
        </div>
      </div>
      <div class="columns">
        <div class="column">
          <ec-field
            id="phone"
          >
            <template #label>
              Votre numéro de téléphone <validation-icon-switch :state="fields.phone.confirmed" />
            </template>
            <div class="field has-addons">
              <div class="control is-expanded">
                <client-only>
                  <vue-tel-input
                    v-model="fields.phone.original"
                    name="phone"
                    default-country="FR"
                    :disabled-fetching-country="false"
                  />
                </client-only>
              </div>
              <div class="control">
                <button
                  v-if="old.phone.original !== fields.phone.original || !fields.phone.confirmed"
                  type="button"
                  class="button is-primary"
                  @click="sendForm('phone')"
                >
                  Vérifier
                </button>
              </div>
            </div>
          </ec-field>
        </div>
        <div class="column">
          <ec-field
            v-if="old.phone.original !== fields.phone.original || !fields.phone.confirmed"
            field-id="phone_token"
            label="Code de confirmation téléphone"
          >
            <div class="field has-addons">
              <div class="control is-expanded">
                <input
                  id="phone_token"
                  v-model="fields.phone.token"
                  type="text"
                  class="input"
                  name="phone_token"
                  :disabled="fields.phone.confirmed"
                  placeholder="Tapez le code de confirmation reçu sur votre téléphone"
                >
              </div>
              <div class="control">
                <button
                  type="button"
                  class="button is-primary"
                  :disabled="fields.phone.confirmed"
                  @click="sendForm()"
                >
                  OK
                </button>
              </div>
            </div>
          </ec-field>
        </div>
      </div>
      <div class="columns">
        <div class="column">
          <ec-field
            field-id="password"
            label="Votre mot de passe"
          >
            <ec-password
              id="password"
              v-model="fields.password"
            />
          </ec-field>
        </div>

        <div class="column">
          <ec-field
            field-id="password_confirm"
            label="Confirmation de mot de passe"
          >
            <ec-password-confirmation
              id="password_confirm"
              v-model="fields.password_confirm"
              :compare-to="fields.password"
            />
          </ec-field>
        </div>
      </div>
      <ec-field class="rgpd">
        <input
          v-model="fields.gprd"
          required
          :true-value="fields.gprd || new Date()"
          type="checkbox"
        >
        J’accepte que mes données soient traitées par le régulateur du service e-Chauffeur afin que ma demande de course
        soit prise en compte, sous <nuxt-link :to="{name: 'conditions'}">
          les conditions suivantes
        </nuxt-link>.
      </ec-field>
      <div class="has-text-centered">
        <button
          type="submit"
          class="button is-primary"
        >
          Sauvegarder
        </button>
        <help-button class="help-button">
          Besoin d'aide ?
        </help-button>
        <button
          type="button"
          class="delete-button"
          @click="toggleModal"
        >
          Vous souhaitez supprimer votre compte ?
        </button>
      </div>
    </form>
    <modal
      :active="isModalActive"
      title="Suppression du compte"
      content="Êtes-vous sûr de vouloir supprimer votre compte ?"
      @toggle-modal="toggleModal"
      @action="deleteAccount"
    />
  </main>
</template>

<script>
import merge from 'lodash.merge';
import { VueTelInput } from 'vue-tel-input';
import helpButton from '~/components/help.vue';
import modal from '~/components/modal.vue';
import ecPassword from '~/components/form/password.vue';
import ecPasswordConfirmation from '~/components/form/password-confirmation.vue';

import validationIconSwitch from '~/components/validation-icon-switch.vue';

const UPDATABLE_FIELDS = ['email', 'email_confirmed', 'firstname', 'lastname', 'phone(original,confirmed)', 'gprd'];
export default {
  auth: false,
  components: {
    ecPassword,
    ecPasswordConfirmation,
    helpButton,
    validationIconSwitch,
    modal,
    VueTelInput,
  },
  async asyncData({
    redirect, $auth, $api, query: { token, email },
  }) {
    if (token && email) {
      try {
        await $auth.login({ data: { token, email } });
      } catch (e) {
        throw new Error('Email ou code de vérification non reconnu.');
      }
    }
    if (!$auth.loggedIn) {
      return redirect({ name: 'login' });
    }
    const fields = {};
    try {
      const { data } = await $api.query('jwt').setMask(UPDATABLE_FIELDS.concat('id')).user();
      Object.assign(fields, data);
    } catch (e) {
      throw new Error('Erreur dans la récupération de vos données utilisateur. '
        + 'Essayez de vous déconnecter puis de vous reconnecter');
    }
    return {
      token,
      email,
      id: fields.id,
      old: merge({ email: null, phone: { original: null } }, fields),
      fields: merge({
        firstname: null,
        lastname: null,
        email: null,
        email_token: null,
        phone: {
          original: null,
          token: null,
        },
        password: null,
      }, fields),
    };
  },
  data() {
    return {
      isModalActive: false,
    };
  },
  watchQuery: ['token', 'email'],
  methods: {
    async sendForm(sendToken = false) {
      if ((this.fields.password || '') !== (this.fields.password_confirm || '')) {
        this.$toast.error('Le mot de passe et sa confirmation ne correspondent pas.');
        return;
      }
      try {
        const { data: updatedUser } = await this.$api.query('users')
          .setMask(UPDATABLE_FIELDS.join(','))
          .edit(this.id, this.fields)
          .setSendToken(sendToken);
        merge(this.fields, updatedUser);
        merge(this.old, updatedUser);
        if (sendToken) {
          this.$toast.success('Un code de confirmation vous a été envoyé.');
        } else {
          this.$toast.success('La mise à jour de votre compte a été prise en compte. '
            + 'Pour commander une course, rendez vous dans le menu "Nouvelle course".');
        }
      } catch (e) {
        if (sendToken) {
          this.$toast.error('Une erreur est survenue lors de l\'envoi du code de confirmation');
        } else {
          this.$toast.error('Une erreur est survenue lors de l\'enregistrement de vos modifications.');
        }
      }
    },
    async deleteAccount() {
      try {
        await this.$api.query('users').delete(this.$auth.user.id);
        this.$auth.logout();
      } catch (e) {
        this.$toast.error('Une erreur est survenue lors de la suppression du compte');
      } finally {
        this.$router.push('/');
        this.$toast.success('Compte supprimé avec succès, vous êtes maintenant déconnecté.');
      }
    },
    toggleModal() {
      this.isModalActive = !this.isModalActive;
    },
  },
};
</script>
<style lang="scss" scoped>
  @import "~assets/css/head";
  $field-color: #abb8cb;
  $text-color: $blue-medium;

  main {
    margin-top: 1em;
  }

  /deep/ .label small {
    font-weight: normal;
    &:before {
      content: ' - ';
    }
  }

  .help-button /deep/ .button {
    color: $primary;
    text-decoration: none;
  }

  .rgpd {
    color: $blue-medium;
    a {
      color: $blue-medium;
      text-decoration: underline;
    }
  }

  @media screen and (max-width: $desktop - 1) {
    form {
      padding: 10px;
    }
  }

  .delete-button {
    background: none;
    border: none;
    color: $primary;
    font-size: 1rem;
    font-weight: 700;
    cursor: pointer;
  }
</style>
